﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: IDendrogramNode.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-12-08 8:26 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System.Collections.Generic;
using System.Linq;

namespace BOL.Algorithms.Clustering
{
    public interface IDendrogramNode<TElement> : IGrouping<int, TElement>
    {
        IList<TElement> Elements { get; }

        bool IsRoot { get; }
        bool IsLeaf { get; }
        IDendrogramNode<TElement> Parent { get; set; }
        IList<IDendrogramNode<TElement>> Children { get; }
        int Count { get; }
        int Depth { get; }
        void AddChild(IDendrogramNode<TElement> child);
        void RemoveChild(IDendrogramNode<TElement> child);
        void ToString(ref string prefix, int level);
    }
}