﻿#region Copyright information
// 
// Copyright © 2005-2012 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: GeneSet.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-11-06 11:45 AM
// - Last Modified: 2012-11-30 9:01 AM
// 
#endregion
using System.Collections.Generic;

namespace BOL.Algorithms.Microarray.SignificanceAnalysis
{
    public class GeneSet : HashSet<Gene>, ISignificant
    {
        #region Public properties

        public double Statistic { get; set; }
        public double PValue { get; set; }

        #endregion

        #region Constructor

        public GeneSet(IEnumerable<Gene> genes)
            : base(genes)
        {
            Statistic = 0.0;
            PValue = 0.0;
        }

        #endregion
    }
}
