﻿#region Copyright information
// 
// Copyright © 2005-2012 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: ISignificanceAnalysis.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-11-06 11:16 AM
// - Last Modified: 2012-11-30 9:01 AM
// 
#endregion
using System.Collections.Generic;

namespace BOL.Algorithms.Microarray.SignificanceAnalysis
{
    public interface ISignificanceAnalysis<out T>
        where T: ISignificant
    {
        IEnumerable<T> Entries { get; }
        ResponseType ResponseType { get; }
        int NumberOfPermutations { get; }
    }
}