#region Copyright information
// 
// Copyright  2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: IOptimizer.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2013-01-24 4:34 PM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
namespace BOL.Algorithms.Optimization
{
    /// <summary>
    /// Provides a optimizer which maximize or minimize an optimizable.
    /// </summary>
    public interface IOptimizer : IIterative, IConvergeable, IVerbose
    {
        /// <summary>Gets an objective function.</summary>
        IObjectiveFunction Function { get; }

        /// <summary>Returns whether it is converged or not.</summary>
        double[] Optimize(double[] initial);
    }

    //public interface IOptimizerByValue
    //{
    //    /// <summary>Gets an optimizable by value.</summary>
    //    IOptimizableByValue Optimizable { get; }
    //}

    //public interface IOptimizerByGradient
    //{
    //    /// <summary>Gets or sets an optimizable by gradient.</summary>
    //    IOptimizableByGradient Optimizable { get; }
    //}

    //public interface IOptimizerByHessian
    //{
    //    /// <summary>Gets or sets an optimizable by hessian.</summary>
    //    IOptimizableByHessian Optimizable { get; }
    //}

    //public interface IOptimizerBySimulatedAnnealing : IOptimizerByValue
    //{
    //    double CoolingRate { get; }
    //}
}
