﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: WriterBase.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System.IO;

namespace BOL.IO
{
    public abstract class WriterBase : IWriter
    {
        #region Private variables

        protected readonly StreamWriter StreamWriter;

		#endregion

		#region Constructors

        protected WriterBase(Stream stream)
        {
            StreamWriter = new StreamWriter(stream);
        }

        protected WriterBase(string path) :
            this(new FileStream(path, FileMode.Create)) { }

		#endregion

        #region Public methods

        public void Close()
		{
            StreamWriter.Close();
        }

        public abstract bool Write();

        #endregion
    }
}
