﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: RootMeanSquareNorm.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;

namespace BOL.Linq.Descriptive
{
    public static partial class Descriptive
    {
        public static decimal RootMeanSquareNorm(this IEnumerable<decimal> source)
        {
            return (decimal)source.Select(x => (double)x).RootMeanSquareNorm();
        }

        public static double RootMeanSquareNorm(this IEnumerable<double> source)
        {
            return Math.Sqrt(source.Sum(x => x * x));
        }

        public static float RootMeanSquareNorm(this IEnumerable<float> source)
        {
            return (float)source.Select(x => (double)x).RootMeanSquareNorm();
        }

        public static int RootMeanSquareNorm(this IEnumerable<int> source)
        {
            return (int)source.Select(x => (double)x).RootMeanSquareNorm();
        }

        public static long RootMeanSquareNorm(this IEnumerable<long> source)
        {
            return (long)source.Select(x => (double)x).RootMeanSquareNorm();
        }

        public static decimal RootMeanSquareNorm<TSource>(this IEnumerable<TSource> source, Func<TSource, decimal> selector)
        {
            return source.Select(selector).RootMeanSquareNorm();
        }

        public static double RootMeanSquareNorm<TSource>(this IEnumerable<TSource> source, Func<TSource, double> selector)
        {
            return source.Select(selector).RootMeanSquareNorm();
        }

        public static float RootMeanSquareNorm<TSource>(this IEnumerable<TSource> source, Func<TSource, float> selector)
        {
            return source.Select(selector).RootMeanSquareNorm();
        }

        public static int RootMeanSquareNorm<TSource>(this IEnumerable<TSource> source, Func<TSource, int> selector)
        {
            return source.Select(selector).RootMeanSquareNorm();
        }

        public static long RootMeanSquareNorm<TSource>(this IEnumerable<TSource> source, Func<TSource, long> selector)
        {
            return source.Select(selector).RootMeanSquareNorm();
        }
    }
}
