﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: Ellenberg.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;

namespace BOL.Linq.Distances
{
    public static partial class Similarity
    {
        public static double Ellenberg(this IEnumerable<double> first, IEnumerable<double> second)
        {
            var zip = first.Zip(second, (f, s) => new { Sum = f + s, NotEqualToZero = (f * s).Equals(0) ? 0 : 1, EqualToZero = (f * s).Equals(0) ? 1 : 0 }).ToList();
            
            return zip.Sum(z => z.Sum * z.NotEqualToZero) / zip.Sum(z => z.Sum * z.EqualToZero);
        }
    }
}
