﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: Michael.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;
using System.Collections.Generic;

namespace BOL.Linq.Distances
{
    public static partial class Similarity
    {
        /// <summary>
        ///                 4 * (ad - bc)
        /// Michael = -------------------------
        ///           (a + d) ^ 2 + (b + c) ^ 2
        /// </summary>
        public static double Michael(this IEnumerable<bool> first, IEnumerable<bool> second)
        {
            var bc = first.BinaryCardinality(second);

            return 4 * (bc.Item1 * bc.Item4 - bc.Item2 * bc.Item3) / (Math.Pow(bc.Item1 + bc.Item4, 2) + Math.Pow(bc.Item2 + bc.Item3, 2));
        }
    }
}
