﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: SequentialTake.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System.Collections.Generic;
using System.Linq;

namespace BOL.Linq
{
    public static partial class Linq
    {
        public static IEnumerable<IEnumerable<TSource>> SequentialTake<TSource>(this IEnumerable<TSource> source, int n)
        {
            var list = source.ToList();
            var list2 = list.Concat(list).ToList();
            var count = list.Count;

            for (var i = 0; i < count; i++)
                yield return list2.Skip(i).Take(n);
        }
    }
}

