#region Copyright information
// 
// Copyright  2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: InformationTheoryFunctions.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;

namespace BOL.Maths.Functions
{
    /// <summary>
    /// Provides constants or static methods for information theory.
    /// </summary>
    public static class InformationTheoryFunctions
    {
        public static double ToNats(double bits)
        {
            return bits * Math.Log(2);
        }

        public static double ToBits(double nats)
        {
            return nats / Math.Log(2);
        }
    }
}
