﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: OneSampleTestBase.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;

namespace BOL.Maths.Statistics.HypothesisTest
{
    public abstract class OneSampleTestBase<T> : TestBase
    {
        #region protected variables

        protected T[] Sample;
        protected int SampleSize;

        #endregion

        #region Constructor

        protected OneSampleTestBase(TestType type, double alpha, double nullValue, IEnumerable<T> sample)
            : base(type, alpha, nullValue)
        {
            if (sample == null)
                throw new ArgumentNullException("sample");
            
            Sample = sample.ToArray();
            SampleSize = Sample.Count();
            if (SampleSize == 0)
                throw new ArgumentException("Sample is empty.", "sample");
        }

        #endregion
    }
}
