﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: TwoSampleMeanTestBase.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-09-06 11:39 AM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System.Collections.Generic;
using System.Linq;

namespace BOL.Maths.Statistics.HypothesisTest
{
    public abstract class TwoSampleMeanTestBase : TwoSampleTestBase<double>
    {
        #region Protected methods

        protected abstract double MeanDifferenceStandardError();

        protected override double PointEstimate()
        {
            return Sample1.Average() - Sample2.Average();
        }

        protected override double PointEstimateStandardError()
        {
            return MeanDifferenceStandardError();
        }

        #endregion

        #region Constructor

        protected TwoSampleMeanTestBase(TestType type, double alpha, double nullValue, IEnumerable<double> sample1, IEnumerable<double> sample2)
            : base(type, alpha, nullValue, sample1, sample2) { }

        #endregion
    }
}
