﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: TissueTypes.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2013-01-25 3:25 PM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;
using System.Runtime.Serialization;

namespace BOL.Models.Features
{
    /// <summary>
    /// Represent a tissue type.
    /// </summary>
    [Flags]
    [DataContract]
    public enum TissueTypes : uint
    {
        [EnumMember]
        None = 0 << 0,

        [EnumMember]
        Bladder = 1 << 0,

        [EnumMember]
        Blood = 1 << 1,

        [EnumMember]
        Bone = 1 << 2,

        [EnumMember]
        BoneMarrow = 1 << 3,

        [EnumMember]
        Brain = 1 << 4,

        [EnumMember]
        Cervix = 1 << 5,

        [EnumMember]
        Colon = 1 << 6,

        [EnumMember]
        Eye = 1 << 7,

        [EnumMember]
        Heart = 1 << 8,

        [EnumMember]
        Kidney = 1 << 9,

        [EnumMember]
        Larynx = 1 << 10,

        [EnumMember]
        Liver = 1 << 11,

        [EnumMember]
        Lung = 1 << 12,

        [EnumMember]
        Lymph = 1 << 13,

        [EnumMember]
        Mammary = 1 << 14,

        [EnumMember]
        Muscle = 1 << 15,

        [EnumMember]
        Ovary = 1 << 16,

        [EnumMember]
        Pancreas = 1 << 17,

        [EnumMember]
        PeripheralNervousSystem = 1 << 18,

        [EnumMember]
        Placenta = 1 << 19,

        [EnumMember]
        Prostate = 1 << 20,

        [EnumMember]
        Skin = 1 << 21,

        [EnumMember]
        SmallIntestine = 1 << 22,

        [EnumMember]
        SoftTissue = 1 << 23,

        [EnumMember]
        Spleen = 1 << 24,

        [EnumMember]
        Stomach = 1 << 25,

        [EnumMember]
        Testis = 1 << 26,

        [EnumMember]
        Thymus = 1 << 27,

        [EnumMember]
        Tongue = 1 << 28,

        [EnumMember]
        Uterus = 1 << 29
    }
}
