﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: Dna4Bit.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2013-01-25 3:25 PM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
namespace BOL.Models.Seq
{
    /// <summary>
    /// 4-bit DNA struct
    /// ----------------------------
    /// Sym Meaning Bin  Hex Dec
    /// ----------------------------
    ///      None   0000 0x0  0
    ///  A     A    0001 0x1  1
    ///  C     C    0010 0x2  2
    ///  G     G    0100 0x4  4
    ///  T     T    1000 0x8  8
    ///  K    G/T   1100 0xC 12
    ///  M    A/C   0011 0x3  3
    ///  R    A/G   0101 0x5  5
    ///  S    C/G   0110 0x6  6
    ///  W    A/T   1001 0x9  9
    ///  Y    C/T   1010 0xA 10
    ///  B   C/G/T  1110 0xE 14 
    ///  D   A/G/T  1101 0xD 13
    ///  H   A/C/T  1011 0xB 11
    ///  V   A/C/G  0111 0x7  7
    ///  N  A/G/C/T 1111 0xF 15
    /// ---------------------------
    /// </summary>
    public enum Dna4Bit : byte
    {
        _ = 0,
        A = 1,
        C = 2,
        G = 4,
        T = 8,
        K = 12,
        M = 3,
        R = 5,
        S = 6,
        W = 9,
        Y = 10,
        B = 14,
        D = 13,
        H = 11,
        V = 7,
        N = 15
    }
}