﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: ISequence.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2013-01-25 3:25 PM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;
using System.Collections.Generic;

namespace BOL.Models.Seq
{
    public interface ISequence<T> : ICloneable, IDirective, IEnumerable<T>, IEquatable<ISequence<T>>
    {
        int Length { get; }

        ISequence<T> Subsequence(int startIndex, int length);
        
        ISequence<T> Subsequence(int startIndex);
        
        ISequence<T> Trim(T gap);
        
        ISequence<T> TrimStart(T gap);
        
        ISequence<T> TrimEnd(T gap);

        ISequence<T> PadLeft(T gap, int width);

        ISequence<T> PadRight(T gap, int width);

        T[] ToArray();
    }
}
