﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: IAtomContainer.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-11-13 3:17 PM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System.Collections.Generic;

namespace BOL.Models.Structure
{
	public interface IAtomContainer
	{
        IList<IAtom> Atoms { get; set; }

		int NumberOfAtoms { get;}
		void AddAtom(IAtom atom);
		void AddAtom(IEnumerable<IAtom> atoms);
		void ClearAtom();
		bool ContainsAtom(IAtom atom);
        void InsertAtom(int index, IAtom atom);
		void RemoveAtom(IAtom atom);
		void RemoveAtom(IEnumerable<IAtom> atoms);
	}
}
