﻿#region Copyright information
// 
// Copyright © 2005-2013 Yongkee Cho. All rights reserved.
// 
// This code is a part of the Biological Object Library and governed under the terms of the
// GNU Lesser General  Public License (LGPL) version 2.1 which accompanies this distribution.
// For more information on the LGPL, please visit http://bol.codeplex.com/license.
// 
// - Filename: ResidueTypes.cs
// - Author: Yongkee Cho
// - Email: yongkeecho@gmail.com
// - Date Created: 2012-11-13 3:17 PM
// - Last Modified: 2013-01-25 3:59 PM
// 
#endregion
using System;

namespace BOL.Models.Structure
{
    /// <summary>Residue types</summary>
    [Flags]
    public enum ResidueTypes : uint
    {
        // why not start from 0 << 0, 0 << 1
        Acidic = 1 << 1,
        Acyclic = 1 << 2,
        Aliphatic = 1 << 3,
        Aromatic = 1 << 4,
        Basic = 1 << 5,
        Buried = 1 << 6,
        Charged = 1 << 7,
        Cyclic = 1 << 8,
        Hydrophobic = 1 << 9,
        Large = 1 << 10,
        Medium = 1 << 11,
        Negative = 1 << 12,
        Neutral = 1 << 13,
        Polar = 1 << 14,
        Positive = 1 << 15,
        Small = 1 << 16,
        Surface = 1 << 17,
        Ligand = 1 << 18,
        SugarPhosphate = 1 << 19
    }
}
